# IDPs

IDPs (or Individual Development Plans) help managers and employees collaborate on career paths. They support individual action items to help keep everyone on track.

## GET /api/v1/idp

> List IDPs

```json
{"openapi":"3.1.0","info":{"title":"Peoplelogic API","version":"1.0.0"},"tags":[{"name":"IDPs","description":"IDPs (or Individual Development Plans) help managers and employees collaborate on career paths. They support individual action items to help keep everyone on track."}],"servers":[{"url":"https://api.peoplelogic.dev"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"Idp":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"organization":{"type":"string","format":"uuid"},"name":{"type":"string"},"active":{"type":"boolean"},"type":{"type":"string"},"startDate":{"type":"string","format":"date"},"endDate":{"type":"string","format":"date"},"status":{"$ref":"#/components/schemas/StatusInfo"},"created":{"$ref":"#/components/schemas/CreationInfo"},"assignees":{"type":"array","items":{"$ref":"#/components/schemas/EntityAssignee"}},"tasks":{"type":"array","items":{"$ref":"#/components/schemas/Task"}},"notes":{"type":"array","items":{"$ref":"#/components/schemas/Note"}},"sharing":{"$ref":"#/components/schemas/SharingInfo"}},"required":["id","organization","name","active","type","startDate","status","created","sharing"]},"StatusInfo":{"type":"object","properties":{"current":{"type":"string"},"changedAt":{"type":"string","format":"date-time"},"changedBy":{"type":"string","format":"uuid"}},"required":["current"]},"CreationInfo":{"type":"object","properties":{"createdAt":{"type":"string","format":"date-time"},"createdBy":{"type":"string","format":"uuid"}},"required":["createdAt"]},"EntityAssignee":{"type":"object","properties":{"entityId":{"type":"string","format":"uuid"},"entityType":{"type":"string"}},"required":["entityId","entityType"]},"Task":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"name":{"type":"string"},"active":{"type":"boolean"},"status":{"$ref":"#/components/schemas/StatusInfo"},"created":{"$ref":"#/components/schemas/CreationInfo"},"assignees":{"type":"array","items":{"$ref":"#/components/schemas/EntityAssignee"}},"organization":{"type":"string","format":"uuid"},"description":{"type":"string"},"dueDate":{"type":"string","format":"date"},"connectedTo":{"$ref":"#/components/schemas/EntityInfo"},"notes":{"type":"array","items":{"$ref":"#/components/schemas/Note"}},"order":{"type":"integer"},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/EntityMapping"}}},"required":["id","name","active","status","created","organization","order"]},"EntityInfo":{"type":"object","properties":{"entityId":{"type":"string","format":"uuid"},"type":{"type":"string"},"organization":{"type":"string","format":"uuid"}},"required":["entityId","type"]},"Note":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"note":{"type":"string"},"author":{"type":"string","format":"uuid"},"createdAt":{"type":"string","format":"date-time"}}},"EntityMapping":{"type":"object","properties":{"app":{"type":"string","format":"uuid"},"namespace":{"type":"string"},"mappedId":{"type":"string"},"reference":{"type":"string"},"mappingData":{"type":"object","additionalProperties":{"type":"string"}},"mappingSecrets":{"type":"object","additionalProperties":{"type":"string"}}},"required":["app","mappedId","mappingData","mappingSecrets"]},"SharingInfo":{"type":"object","properties":{"visibility":{"type":"string"},"ownerId":{"type":"string","format":"uuid"}}}}},"paths":{"/api/v1/idp":{"get":{"tags":["IDPs"],"summary":"List IDPs","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Idp"}}}}},"400":{"description":"Bad Request – invalid request payload."},"401":{"description":"Unauthorized – missing or invalid JWT."},"403":{"description":"Forbidden – insufficient permissions."},"404":{"description":"Not Found – no Entity with that ID."}}}}}}
```

## POST /api/v1/idp

> Create IDP

```json
{"openapi":"3.1.0","info":{"title":"Peoplelogic API","version":"1.0.0"},"tags":[{"name":"IDPs","description":"IDPs (or Individual Development Plans) help managers and employees collaborate on career paths. They support individual action items to help keep everyone on track."}],"servers":[{"url":"https://api.peoplelogic.dev"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"IdpRequest":{"type":"object","properties":{"name":{"type":"string"},"startDate":{"type":"string","format":"date"},"endDate":{"type":"string","format":"date"},"type":{"type":"string"},"visibility":{"type":"string"},"owner":{"type":"string","format":"uuid"}},"required":["name","startDate","type"]},"Idp":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"organization":{"type":"string","format":"uuid"},"name":{"type":"string"},"active":{"type":"boolean"},"type":{"type":"string"},"startDate":{"type":"string","format":"date"},"endDate":{"type":"string","format":"date"},"status":{"$ref":"#/components/schemas/StatusInfo"},"created":{"$ref":"#/components/schemas/CreationInfo"},"assignees":{"type":"array","items":{"$ref":"#/components/schemas/EntityAssignee"}},"tasks":{"type":"array","items":{"$ref":"#/components/schemas/Task"}},"notes":{"type":"array","items":{"$ref":"#/components/schemas/Note"}},"sharing":{"$ref":"#/components/schemas/SharingInfo"}},"required":["id","organization","name","active","type","startDate","status","created","sharing"]},"StatusInfo":{"type":"object","properties":{"current":{"type":"string"},"changedAt":{"type":"string","format":"date-time"},"changedBy":{"type":"string","format":"uuid"}},"required":["current"]},"CreationInfo":{"type":"object","properties":{"createdAt":{"type":"string","format":"date-time"},"createdBy":{"type":"string","format":"uuid"}},"required":["createdAt"]},"EntityAssignee":{"type":"object","properties":{"entityId":{"type":"string","format":"uuid"},"entityType":{"type":"string"}},"required":["entityId","entityType"]},"Task":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"name":{"type":"string"},"active":{"type":"boolean"},"status":{"$ref":"#/components/schemas/StatusInfo"},"created":{"$ref":"#/components/schemas/CreationInfo"},"assignees":{"type":"array","items":{"$ref":"#/components/schemas/EntityAssignee"}},"organization":{"type":"string","format":"uuid"},"description":{"type":"string"},"dueDate":{"type":"string","format":"date"},"connectedTo":{"$ref":"#/components/schemas/EntityInfo"},"notes":{"type":"array","items":{"$ref":"#/components/schemas/Note"}},"order":{"type":"integer"},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/EntityMapping"}}},"required":["id","name","active","status","created","organization","order"]},"EntityInfo":{"type":"object","properties":{"entityId":{"type":"string","format":"uuid"},"type":{"type":"string"},"organization":{"type":"string","format":"uuid"}},"required":["entityId","type"]},"Note":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"note":{"type":"string"},"author":{"type":"string","format":"uuid"},"createdAt":{"type":"string","format":"date-time"}}},"EntityMapping":{"type":"object","properties":{"app":{"type":"string","format":"uuid"},"namespace":{"type":"string"},"mappedId":{"type":"string"},"reference":{"type":"string"},"mappingData":{"type":"object","additionalProperties":{"type":"string"}},"mappingSecrets":{"type":"object","additionalProperties":{"type":"string"}}},"required":["app","mappedId","mappingData","mappingSecrets"]},"SharingInfo":{"type":"object","properties":{"visibility":{"type":"string"},"ownerId":{"type":"string","format":"uuid"}}}}},"paths":{"/api/v1/idp":{"post":{"tags":["IDPs"],"summary":"Create IDP","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/IdpRequest"}}}},"responses":{"201":{"description":"Created","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Idp"}}}},"400":{"description":"Bad Request – invalid request payload."},"401":{"description":"Unauthorized – missing or invalid JWT."},"403":{"description":"Forbidden – insufficient permissions."},"404":{"description":"Not Found – no Entity with that ID."}}}}}}
```

## GET /api/v1/idp/{id}

> Get IDP

```json
{"openapi":"3.1.0","info":{"title":"Peoplelogic API","version":"1.0.0"},"tags":[{"name":"IDPs","description":"IDPs (or Individual Development Plans) help managers and employees collaborate on career paths. They support individual action items to help keep everyone on track."}],"servers":[{"url":"https://api.peoplelogic.dev"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"Idp":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"organization":{"type":"string","format":"uuid"},"name":{"type":"string"},"active":{"type":"boolean"},"type":{"type":"string"},"startDate":{"type":"string","format":"date"},"endDate":{"type":"string","format":"date"},"status":{"$ref":"#/components/schemas/StatusInfo"},"created":{"$ref":"#/components/schemas/CreationInfo"},"assignees":{"type":"array","items":{"$ref":"#/components/schemas/EntityAssignee"}},"tasks":{"type":"array","items":{"$ref":"#/components/schemas/Task"}},"notes":{"type":"array","items":{"$ref":"#/components/schemas/Note"}},"sharing":{"$ref":"#/components/schemas/SharingInfo"}},"required":["id","organization","name","active","type","startDate","status","created","sharing"]},"StatusInfo":{"type":"object","properties":{"current":{"type":"string"},"changedAt":{"type":"string","format":"date-time"},"changedBy":{"type":"string","format":"uuid"}},"required":["current"]},"CreationInfo":{"type":"object","properties":{"createdAt":{"type":"string","format":"date-time"},"createdBy":{"type":"string","format":"uuid"}},"required":["createdAt"]},"EntityAssignee":{"type":"object","properties":{"entityId":{"type":"string","format":"uuid"},"entityType":{"type":"string"}},"required":["entityId","entityType"]},"Task":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"name":{"type":"string"},"active":{"type":"boolean"},"status":{"$ref":"#/components/schemas/StatusInfo"},"created":{"$ref":"#/components/schemas/CreationInfo"},"assignees":{"type":"array","items":{"$ref":"#/components/schemas/EntityAssignee"}},"organization":{"type":"string","format":"uuid"},"description":{"type":"string"},"dueDate":{"type":"string","format":"date"},"connectedTo":{"$ref":"#/components/schemas/EntityInfo"},"notes":{"type":"array","items":{"$ref":"#/components/schemas/Note"}},"order":{"type":"integer"},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/EntityMapping"}}},"required":["id","name","active","status","created","organization","order"]},"EntityInfo":{"type":"object","properties":{"entityId":{"type":"string","format":"uuid"},"type":{"type":"string"},"organization":{"type":"string","format":"uuid"}},"required":["entityId","type"]},"Note":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"note":{"type":"string"},"author":{"type":"string","format":"uuid"},"createdAt":{"type":"string","format":"date-time"}}},"EntityMapping":{"type":"object","properties":{"app":{"type":"string","format":"uuid"},"namespace":{"type":"string"},"mappedId":{"type":"string"},"reference":{"type":"string"},"mappingData":{"type":"object","additionalProperties":{"type":"string"}},"mappingSecrets":{"type":"object","additionalProperties":{"type":"string"}}},"required":["app","mappedId","mappingData","mappingSecrets"]},"SharingInfo":{"type":"object","properties":{"visibility":{"type":"string"},"ownerId":{"type":"string","format":"uuid"}}}}},"paths":{"/api/v1/idp/{id}":{"get":{"tags":["IDPs"],"summary":"Get IDP","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Idp"}}}},"400":{"description":"Bad Request – invalid request payload."},"401":{"description":"Unauthorized – missing or invalid JWT."},"403":{"description":"Forbidden – insufficient permissions."},"404":{"description":"Not Found – no Entity with that ID."}}}}}}
```

## DELETE /api/v1/idp/{id}

> Delete IDP

```json
{"openapi":"3.1.0","info":{"title":"Peoplelogic API","version":"1.0.0"},"tags":[{"name":"IDPs","description":"IDPs (or Individual Development Plans) help managers and employees collaborate on career paths. They support individual action items to help keep everyone on track."}],"servers":[{"url":"https://api.peoplelogic.dev"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}}},"paths":{"/api/v1/idp/{id}":{"delete":{"tags":["IDPs"],"summary":"Delete IDP","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK"},"400":{"description":"Bad Request – invalid request payload."},"401":{"description":"Unauthorized – missing or invalid JWT."},"403":{"description":"Forbidden – insufficient permissions."},"404":{"description":"Not Found – no Entity with that ID."}}}}}}
```

## PATCH /api/v1/idp/{id}

> Update IDP

```json
{"openapi":"3.1.0","info":{"title":"Peoplelogic API","version":"1.0.0"},"tags":[{"name":"IDPs","description":"IDPs (or Individual Development Plans) help managers and employees collaborate on career paths. They support individual action items to help keep everyone on track."}],"servers":[{"url":"https://api.peoplelogic.dev"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"IdpRequest":{"type":"object","properties":{"name":{"type":"string"},"startDate":{"type":"string","format":"date"},"endDate":{"type":"string","format":"date"},"type":{"type":"string"},"visibility":{"type":"string"},"owner":{"type":"string","format":"uuid"}},"required":["name","startDate","type"]},"Idp":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"organization":{"type":"string","format":"uuid"},"name":{"type":"string"},"active":{"type":"boolean"},"type":{"type":"string"},"startDate":{"type":"string","format":"date"},"endDate":{"type":"string","format":"date"},"status":{"$ref":"#/components/schemas/StatusInfo"},"created":{"$ref":"#/components/schemas/CreationInfo"},"assignees":{"type":"array","items":{"$ref":"#/components/schemas/EntityAssignee"}},"tasks":{"type":"array","items":{"$ref":"#/components/schemas/Task"}},"notes":{"type":"array","items":{"$ref":"#/components/schemas/Note"}},"sharing":{"$ref":"#/components/schemas/SharingInfo"}},"required":["id","organization","name","active","type","startDate","status","created","sharing"]},"StatusInfo":{"type":"object","properties":{"current":{"type":"string"},"changedAt":{"type":"string","format":"date-time"},"changedBy":{"type":"string","format":"uuid"}},"required":["current"]},"CreationInfo":{"type":"object","properties":{"createdAt":{"type":"string","format":"date-time"},"createdBy":{"type":"string","format":"uuid"}},"required":["createdAt"]},"EntityAssignee":{"type":"object","properties":{"entityId":{"type":"string","format":"uuid"},"entityType":{"type":"string"}},"required":["entityId","entityType"]},"Task":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"name":{"type":"string"},"active":{"type":"boolean"},"status":{"$ref":"#/components/schemas/StatusInfo"},"created":{"$ref":"#/components/schemas/CreationInfo"},"assignees":{"type":"array","items":{"$ref":"#/components/schemas/EntityAssignee"}},"organization":{"type":"string","format":"uuid"},"description":{"type":"string"},"dueDate":{"type":"string","format":"date"},"connectedTo":{"$ref":"#/components/schemas/EntityInfo"},"notes":{"type":"array","items":{"$ref":"#/components/schemas/Note"}},"order":{"type":"integer"},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/EntityMapping"}}},"required":["id","name","active","status","created","organization","order"]},"EntityInfo":{"type":"object","properties":{"entityId":{"type":"string","format":"uuid"},"type":{"type":"string"},"organization":{"type":"string","format":"uuid"}},"required":["entityId","type"]},"Note":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"note":{"type":"string"},"author":{"type":"string","format":"uuid"},"createdAt":{"type":"string","format":"date-time"}}},"EntityMapping":{"type":"object","properties":{"app":{"type":"string","format":"uuid"},"namespace":{"type":"string"},"mappedId":{"type":"string"},"reference":{"type":"string"},"mappingData":{"type":"object","additionalProperties":{"type":"string"}},"mappingSecrets":{"type":"object","additionalProperties":{"type":"string"}}},"required":["app","mappedId","mappingData","mappingSecrets"]},"SharingInfo":{"type":"object","properties":{"visibility":{"type":"string"},"ownerId":{"type":"string","format":"uuid"}}}}},"paths":{"/api/v1/idp/{id}":{"patch":{"tags":["IDPs"],"summary":"Update IDP","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/IdpRequest"}}}},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Idp"}}}},"400":{"description":"Bad Request – invalid request payload."},"401":{"description":"Unauthorized – missing or invalid JWT."},"403":{"description":"Forbidden – insufficient permissions."},"404":{"description":"Not Found – no Entity with that ID."}}}}}}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.peoplelogic.dev/api/universal-talent-api/idps.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
